Doomsday Engine - Feature #1525

Allow gaps in Sprite animation frame sets
2010-10-28 11:50 - vermil

Status: Closed Start date: 2010-10-28
Priority: Normal % Done: 100%
Assignee: danij

Category: 3rd party compatibility

Target version: 1.15

Description

Not so much a bug, rather an oversight or small limitation in Dday.
When loading sprite containing wads at start up, Dday expects there to be no gaps in the sprites frames.

For instance, if the highest frame of a sprite in the loaded wads is E, Dday expects there to be frames A, B, C and D. If they don't
exist, Dday aborts during start up with a missing frames message.

Dday will still abort over sprites with gaps in their frames, even if the sprites are not actually called by a ded, dehacked etc.

Labels: Data

History

#1 - 2010-10-28 13:48 - danij

In what situation would a missing sprite frame be valid? Seems to me that if you have defined the set {A, B, ..., D} then a missing frame in said set is
an invalid state and one which renders the whole set unusable (we could inject missing "placeholder" frames to get around it however).

#2 - 2012-03-02 16:56 - danij

Upon discussion with Vermil this report should be interpreted thus:
Artifact is a behavioural difference between Doomsday and ZDoom-based source ports.
In the situation where the complete sprite frame set {A, B, ..., D} is expected but not found, behaviour differs:

¢ Doomsday reports a fatal error and startup is aborted.
e ZDoom outputs a warning message and works around the missing frame, rendering nothing when visible.

Additionally, Vermil mentioned that ZDoom defers the sequence validity checks until the sequence is actually used, rather than during startup. This
would obviously be a good idea and should be implemented.

However, therefore, this is not a bug report. Moving to RFE.

#3 - 2013-10-22 11:01 - skyjake
- Tags set to ZDoom
- Subject changed from Dday expects there to be no gaps in the sprites frames. to Handling gaps in the sprite frames (in a WAD)

- Category set to 3rd party compatibility

#4 - 2013-10-22 11:01 - skyjake
- Tags changed from ZDoom to ZDoom, Mod, Sprites

#5 - 2015-03-07 07:40 - danij

- Subject changed from Handling gaps in the sprite frames (in a WAD) to Allow gaps in Sprite animation frame sets
- Status changed from New to Closed

- Assignee set to danij

- Target version setto 1.15

- % Done changed from 0 to 100

#6 - 2015-03-07 07:43 - danij
As of commit f4ab2ee Doomsday now supports gaps in Sprite frame animation sets and mimics ZDoom by hiding the sprite if asked to draw using a
non-existent frame.
